Index: serefpolicy-contrib-20140730/policykit.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/policykit.fc
+++ serefpolicy-contrib-20140730/policykit.fc
@@ -1,23 +1,22 @@
-/usr/lib/polkit-1/polkitd	--	gen_context(system_u:object_r:policykit_exec_t,s0)
-/usr/lib/polkit-1/polkit-agent-helper-1	--	gen_context(system_u:object_r:policykit_auth_exec_t,s0)
-
-/usr/lib/policykit/polkit-read-auth-helper	--	gen_context(system_u:object_r:policykit_auth_exec_t,s0)
-/usr/lib/policykit/polkit-grant-helper.*	--	gen_context(system_u:object_r:policykit_grant_exec_t,s0)
-/usr/lib/policykit/polkit-resolve-exe-helper.*	--	gen_context(system_u:object_r:policykit_resolve_exec_t,s0)
-/usr/lib/policykit/polkitd	--	gen_context(system_u:object_r:policykit_exec_t,s0)
-/usr/lib/policykit-1/polkit-agent-helper-1	--	gen_context(system_u:object_r:policykit_auth_exec_t,s0)
-/usr/lib/policykit-1/polkitd	--	gen_context(system_u:object_r:policykit_exec_t,s0)
+/usr/lib/policykit/polkit-read-auth-helper --	gen_context(system_u:object_r:policykit_auth_exec_t,s0)
+/usr/bin/pkla-check-authorization 	   --	gen_context(system_u:object_r:policykit_auth_exec_t,s0)
+/usr/lib/policykit/polkit-grant-helper.*   --	gen_context(system_u:object_r:policykit_grant_exec_t,s0)
+/usr/lib/policykit/polkit-resolve-exe-helper.* -- gen_context(system_u:object_r:policykit_resolve_exec_t,s0)
+/usr/lib/policykit/polkitd		--	gen_context(system_u:object_r:policykit_exec_t,s0)
+/usr/lib/polkit-1/polkitd		--	gen_context(system_u:object_r:policykit_exec_t,s0)
 
 /usr/libexec/polkit-read-auth-helper	--	gen_context(system_u:object_r:policykit_auth_exec_t,s0)
 /usr/libexec/polkit-grant-helper.*	--	gen_context(system_u:object_r:policykit_grant_exec_t,s0)
-/usr/libexec/polkit-resolve-exe-helper.*	--	gen_context(system_u:object_r:policykit_resolve_exec_t,s0)
-/usr/libexec/polkitd.*	--	gen_context(system_u:object_r:policykit_exec_t,s0)
-/usr/libexec/polkit-1/polkit-agent-helper-1	--	gen_context(system_u:object_r:policykit_auth_exec_t,s0)
-/usr/libexec/polkit-1/polkitd.*	--	gen_context(system_u:object_r:policykit_exec_t,s0)
+/usr/libexec/polkit-resolve-exe-helper.* --	gen_context(system_u:object_r:policykit_resolve_exec_t,s0)
+/usr/libexec/polkitd.*			--	gen_context(system_u:object_r:policykit_exec_t,s0)
+/usr/libexec/polkit-1/polkit-agent-helper-1 --	gen_context(system_u:object_r:policykit_auth_exec_t,s0)
+/usr/lib/polkit-1/polkit-agent-helper-1  --	gen_context(system_u:object_r:policykit_auth_exec_t,s0)
+/usr/libexec/kde4/polkit-kde-authentication-agent-1 --  gen_context(system_u:object_r:policykit_auth_exec_t,s0)
+/usr/libexec/polkit-1/polkitd.*		--	gen_context(system_u:object_r:policykit_exec_t,s0)
 
-/var/lib/misc/PolicyKit.reload	gen_context(system_u:object_r:policykit_reload_t,s0)
-/var/lib/PolicyKit(/.*)?	gen_context(system_u:object_r:policykit_var_lib_t,s0)
-/var/lib/polkit-1(/.*)?	gen_context(system_u:object_r:policykit_var_lib_t,s0)
-/var/lib/PolicyKit-public(/.*)?	gen_context(system_u:object_r:policykit_var_lib_t,s0)
+/var/lib/misc/PolicyKit.reload			gen_context(system_u:object_r:policykit_reload_t,s0)
+/var/lib/PolicyKit(/.*)?			gen_context(system_u:object_r:policykit_var_lib_t,s0)
+/var/lib/polkit-1(/.*)?				gen_context(system_u:object_r:policykit_var_lib_t,s0)
+/var/lib/PolicyKit-public(/.*)?			gen_context(system_u:object_r:policykit_var_lib_t,s0)
+/var/run/PolicyKit(/.*)?			gen_context(system_u:object_r:policykit_var_run_t,s0)
 
-/var/run/PolicyKit(/.*)?	gen_context(system_u:object_r:policykit_var_run_t,s0)
Index: serefpolicy-contrib-20140730/policykit.if
===================================================================
--- serefpolicy-contrib-20140730.orig/policykit.if
+++ serefpolicy-contrib-20140730/policykit.if
@@ -17,6 +17,8 @@ interface(`policykit_dbus_chat',`
 		class dbus send_msg;
 	')
 
+	ps_process_pattern(policykit_t, $1)
+
 	allow $1 policykit_t:dbus send_msg;
 	allow policykit_t $1:dbus send_msg;
 ')
@@ -24,7 +26,7 @@ interface(`policykit_dbus_chat',`
 ########################################
 ## <summary>
 ##	Send and receive messages from
-##	policykit auth over dbus.
+##	policykit over dbus.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -38,6 +40,8 @@ interface(`policykit_dbus_chat_auth',`
 		class dbus send_msg;
 	')
 
+	ps_process_pattern(policykit_auth_t, $1)
+
 	allow $1 policykit_auth_t:dbus send_msg;
 	allow policykit_auth_t $1:dbus send_msg;
 ')
@@ -47,9 +51,9 @@ interface(`policykit_dbus_chat_auth',`
 ##	Execute a domain transition to run polkit_auth.
 ## </summary>
 ## <param name="domain">
-## <summary>
+##	<summary>
 ##	Domain allowed to transition.
-## </summary>
+##	</summary>
 ## </param>
 #
 interface(`policykit_domtrans_auth',`
@@ -57,15 +61,13 @@ interface(`policykit_domtrans_auth',`
 		type policykit_auth_t, policykit_auth_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, policykit_auth_exec_t, policykit_auth_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute a policy_auth in the policy
-##	auth domain, and allow the specified
-##	role the policy auth domain.
+##	Execute a policy_auth in the policy_auth domain, and
+##	allow the specified role the policy_auth domain,
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -77,24 +79,28 @@ interface(`policykit_domtrans_auth',`
 ##	Role allowed access.
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
 interface(`policykit_run_auth',`
 	gen_require(`
-		attribute_role policykit_auth_roles;
+		type policykit_auth_t;
 	')
 
 	policykit_domtrans_auth($1)
-	roleattribute $2 policykit_auth_roles;
+	role $2 types policykit_auth_t;
+
+	allow $1 policykit_auth_t:process signal;
+	ps_process_pattern(policykit_auth_t, $1)
 ')
 
 ########################################
 ## <summary>
-##	Execute a domain transition to run polkit grant.
+##	Execute a domain transition to run polkit_grant.
 ## </summary>
 ## <param name="domain">
-## <summary>
+##	<summary>
 ##	Domain allowed to transition.
-## </summary>
+##	</summary>
 ## </param>
 #
 interface(`policykit_domtrans_grant',`
@@ -102,15 +108,13 @@ interface(`policykit_domtrans_grant',`
 		type policykit_grant_t, policykit_grant_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, policykit_grant_exec_t, policykit_grant_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute a policy_grant in the policy
-##	grant domain, and allow the specified
-##	role the policy grant domain.
+##	Execute a policy_grant in the policy_grant domain, and
+##	allow the specified role the policy_grant domain,
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -126,16 +130,20 @@ interface(`policykit_domtrans_grant',`
 #
 interface(`policykit_run_grant',`
 	gen_require(`
-		attribute_role policykit_grant_roles;
+		type policykit_grant_t;
 	')
 
 	policykit_domtrans_grant($1)
-	roleattribute $2 policykit_grant_roles;
+	role $2 types policykit_grant_t;
+
+	allow $1 policykit_grant_t:process signal;
+
+	ps_process_pattern(policykit_grant_t, $1)
 ')
 
 ########################################
 ## <summary>
-##	Read policykit reload files.
+##	read policykit reload files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -154,7 +162,7 @@ interface(`policykit_read_reload',`
 
 ########################################
 ## <summary>
-##	Read and write policykit reload files.
+##	rw policykit reload files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -173,12 +181,12 @@ interface(`policykit_rw_reload',`
 
 ########################################
 ## <summary>
-##	Execute a domain transition to run polkit resolve.
+##	Execute a domain transition to run polkit_resolve.
 ## </summary>
 ## <param name="domain">
-## <summary>
+##	<summary>
 ##	Domain allowed to transition.
-## </summary>
+##	</summary>
 ## </param>
 #
 interface(`policykit_domtrans_resolve',`
@@ -186,8 +194,9 @@ interface(`policykit_domtrans_resolve',`
 		type policykit_resolve_t, policykit_resolve_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, policykit_resolve_exec_t, policykit_resolve_t)
+
+	ps_process_pattern(policykit_resolve_t, $1)
 ')
 
 ########################################
@@ -205,13 +214,13 @@ interface(`policykit_search_lib',`
 		type policykit_var_lib_t;
 	')
 
-	files_search_var_lib($1)
 	allow $1 policykit_var_lib_t:dir search_dir_perms;
+	files_search_var_lib($1)
 ')
 
 ########################################
 ## <summary>
-##	Read policykit lib files.
+##	read policykit lib files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -226,4 +235,50 @@ interface(`policykit_read_lib',`
 
 	files_search_var_lib($1)
 	read_files_pattern($1, policykit_var_lib_t, policykit_var_lib_t)
+
+	optional_policy(`
+		# Broken placement
+		cron_read_system_job_lib_files($1)
+	')
+')
+
+#######################################
+## <summary>
+##	The per role template for the policykit module.
+## </summary>
+## <param name="user_role">
+##	<summary>
+##	Role allowed access
+##	</summary>
+## </param>
+## <param name="user_domain">
+##	<summary>
+##	User domain for the role
+##	</summary>
+## </param>
+#
+template(`policykit_role',`
+	policykit_run_auth($2, $1)
+	policykit_run_grant($2, $1)
+	policykit_read_lib($2)
+	policykit_read_reload($2)
+	policykit_dbus_chat($2)
+')
+
+########################################
+## <summary>
+##	Send generic signal to policy_auth
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`policykit_signal_auth',`
+	gen_require(`
+		type policykit_auth_t;
+	')
+
+	allow $1 policykit_auth_t:process signal;
 ')
Index: serefpolicy-contrib-20140730/policykit.te
===================================================================
--- serefpolicy-contrib-20140730.orig/policykit.te
+++ serefpolicy-contrib-20140730/policykit.te
@@ -7,9 +7,6 @@ policy_module(policykit, 1.3.0)
 
 attribute policykit_domain;
 
-attribute_role policykit_auth_roles;
-attribute_role policykit_grant_roles;
-
 type policykit_t, policykit_domain;
 type policykit_exec_t;
 init_daemon_domain(policykit_t, policykit_exec_t)
@@ -17,12 +14,10 @@ init_daemon_domain(policykit_t, policyki
 type policykit_auth_t, policykit_domain;
 type policykit_auth_exec_t;
 init_daemon_domain(policykit_auth_t, policykit_auth_exec_t)
-role policykit_auth_roles types policykit_auth_t;
 
 type policykit_grant_t, policykit_domain;
 type policykit_grant_exec_t;
 init_system_domain(policykit_grant_t, policykit_grant_exec_t)
-role policykit_grant_roles types policykit_grant_t;
 
 type policykit_resolve_t, policykit_domain;
 type policykit_resolve_exec_t;
@@ -42,63 +37,68 @@ files_pid_file(policykit_var_run_t)
 
 #######################################
 #
-# Common policykit domain local policy
+# policykit_domain local policy
 #
 
 allow policykit_domain self:process { execmem getattr };
 allow policykit_domain self:fifo_file rw_fifo_file_perms;
 
-kernel_search_proc(policykit_domain)
-
-corecmd_exec_bin(policykit_domain)
-
 dev_read_sysfs(policykit_domain)
 
-files_read_usr_files(policykit_domain)
-
-logging_send_syslog_msg(policykit_domain)
-
-miscfiles_read_localization(policykit_domain)
-
 ########################################
 #
-# Local policy
+# policykit local policy
 #
 
 allow policykit_t self:capability { dac_override dac_read_search setgid setuid sys_nice sys_ptrace };
 allow policykit_t self:process { getsched setsched signal };
-allow policykit_t self:unix_stream_socket { accept connectto listen };
+allow policykit_t self:unix_dgram_socket create_socket_perms;
+allow policykit_t self:unix_stream_socket { create_stream_socket_perms connectto };
+
+policykit_domtrans_auth(policykit_t)
+allow policykit_t policykit_auth_t:process signal;
+
+can_exec(policykit_t, policykit_exec_t)
+corecmd_exec_bin(policykit_t)
+
+dev_read_sysfs(policykit_t)
 
 rw_files_pattern(policykit_t, policykit_reload_t, policykit_reload_t)
 
+policykit_domtrans_resolve(policykit_t)
+
 manage_files_pattern(policykit_t, policykit_var_lib_t, policykit_var_lib_t)
 
 manage_dirs_pattern(policykit_t, policykit_var_run_t, policykit_var_run_t)
 manage_files_pattern(policykit_t, policykit_var_run_t, policykit_var_run_t)
 files_pid_filetrans(policykit_t, policykit_var_run_t, { file dir })
 
-can_exec(policykit_t, policykit_exec_t)
-
-domtrans_pattern(policykit_t, policykit_auth_exec_t, policykit_auth_t)
-domtrans_pattern(policykit_t, policykit_resolve_exec_t, policykit_resolve_t)
-
-kernel_read_kernel_sysctls(policykit_t)
 kernel_read_system_state(policykit_t)
+kernel_read_kernel_sysctls(policykit_t)
 
 domain_read_all_domains_state(policykit_t)
 
 files_dontaudit_search_all_mountpoints(policykit_t)
 
+fs_getattr_all_fs(policykit_t)
 fs_list_inotifyfs(policykit_t)
+fs_list_cgroup_dirs(policykit_t)
 
 auth_use_nsswitch(policykit_t)
 
+init_list_pid_dirs(policykit_t)
+
+logging_send_syslog_msg(policykit_t)
+
 userdom_getattr_all_users(policykit_t)
 userdom_read_all_users_state(policykit_t)
+userdom_dontaudit_search_admin_dir(policykit_t)
 
 optional_policy(`
 	dbus_system_domain(policykit_t, policykit_exec_t)
 
+	init_dbus_chat(policykit_t)
+
 	optional_policy(`
 		consolekit_dbus_chat(policykit_t)
 	')
@@ -109,29 +109,43 @@ optional_policy(`
 ')
 
 optional_policy(`
+	consolekit_list_pid_files(policykit_t)
 	consolekit_read_pid_files(policykit_t)
 ')
 
 optional_policy(`
-	gnome_read_generic_home_content(policykit_t)
+	kerberos_tmp_filetrans_host_rcache(policykit_t, "host_0")
+	kerberos_manage_host_rcache(policykit_t)
 ')
 
 optional_policy(`
-	kerberos_manage_host_rcache(policykit_t)
-	kerberos_tmp_filetrans_host_rcache(policykit_t, file, "host_0")
+	gnome_read_config(policykit_t)
+')
+
+optional_policy(`
+	systemd_read_logind_sessions_files(policykit_t)
+	systemd_login_list_pid_dirs(policykit_t)
+	systemd_login_read_pid_files(policykit_t)
 ')
 
 ########################################
 #
-# Auth local policy
+# polkit_auth local policy
 #
 
-allow policykit_auth_t self:capability { ipc_lock setgid setuid sys_nice };
+allow policykit_auth_t self:capability { sys_nice ipc_lock setgid setuid };
 dontaudit policykit_auth_t self:capability sys_tty_config;
-allow policykit_auth_t self:process { getsched setsched signal };
-allow policykit_auth_t self:unix_stream_socket { accept listen };
+allow policykit_auth_t self:process { setsched getsched signal };
+
+allow policykit_auth_t self:unix_dgram_socket create_socket_perms;
+allow policykit_auth_t self:unix_stream_socket create_stream_socket_perms;
 
-ps_process_pattern(policykit_auth_t, policykit_domain)
+policykit_dbus_chat(policykit_auth_t)
+
+kernel_read_system_state(policykit_auth_t)
+
+can_exec(policykit_auth_t, policykit_auth_exec_t)
+corecmd_exec_bin(policykit_auth_t)
 
 rw_files_pattern(policykit_auth_t, policykit_reload_t, policykit_reload_t)
 
@@ -145,9 +159,6 @@ manage_dirs_pattern(policykit_auth_t, po
 manage_files_pattern(policykit_auth_t, policykit_var_run_t, policykit_var_run_t)
 files_pid_filetrans(policykit_auth_t, policykit_var_run_t, { file dir })
 
-can_exec(policykit_auth_t, policykit_auth_exec_t)
-
-kernel_read_system_state(policykit_auth_t)
 kernel_dontaudit_search_kernel_sysctl(policykit_auth_t)
 
 dev_read_video_dev(policykit_auth_t)
@@ -157,53 +168,64 @@ files_search_home(policykit_auth_t)
 
 fs_getattr_all_fs(policykit_auth_t)
 fs_search_tmpfs(policykit_auth_t)
+fs_dontaudit_append_ecryptfs_files(policykit_auth_t)
 
 auth_rw_var_auth(policykit_auth_t)
 auth_use_nsswitch(policykit_auth_t)
 auth_domtrans_chk_passwd(policykit_auth_t)
 
+logging_send_syslog_msg(policykit_auth_t)
+
 miscfiles_read_fonts(policykit_auth_t)
 miscfiles_setattr_fonts_cache_dirs(policykit_auth_t)
 
 userdom_dontaudit_read_user_home_content_files(policykit_auth_t)
+userdom_dontaudit_write_user_tmp_files(policykit_auth_t)
+userdom_read_admin_home_files(policykit_auth_t)
 
 optional_policy(`
-	dbus_system_domain(policykit_auth_t, policykit_auth_exec_t)
-	dbus_all_session_bus_client(policykit_auth_t)
+	dbus_system_domain( policykit_auth_t, policykit_auth_exec_t)
+	dbus_session_bus_client(policykit_auth_t)
 
 	optional_policy(`
 		consolekit_dbus_chat(policykit_auth_t)
 	')
-
-	optional_policy(`
-		policykit_dbus_chat(policykit_auth_t)
-	')
 ')
 
 optional_policy(`
+	kernel_search_proc(policykit_auth_t)
 	hal_read_state(policykit_auth_t)
 ')
 
 optional_policy(`
-	kerberos_manage_host_rcache(policykit_auth_t)
-	kerberos_tmp_filetrans_host_rcache(policykit_auth_t, file, "host_0")
+	kerberos_tmp_filetrans_host_rcache(policykit_auth_t, "host_0")
+        kerberos_manage_host_rcache(policykit_auth_t)
 ')
 
 optional_policy(`
 	xserver_stream_connect(policykit_auth_t)
+	xserver_xdm_append_log(policykit_auth_t)
 	xserver_read_xdm_pid(policykit_auth_t)
+	xserver_search_xdm_lib(policykit_auth_t)
+	xserver_create_xdm_tmp_sockets(policykit_auth_t)
 ')
 
 ########################################
 #
-# Grant local policy
+# polkit_grant local policy
 #
 
 allow policykit_grant_t self:capability setuid;
+
 allow policykit_grant_t self:unix_dgram_socket create_socket_perms;
 allow policykit_grant_t self:unix_stream_socket create_stream_socket_perms;
 
-ps_process_pattern(policykit_grant_t, policykit_domain)
+policykit_domtrans_auth(policykit_grant_t)
+
+policykit_domtrans_resolve(policykit_grant_t)
+
+can_exec(policykit_grant_t, policykit_grant_exec_t)
+corecmd_search_bin(policykit_grant_t)
 
 rw_files_pattern(policykit_grant_t, policykit_reload_t, policykit_reload_t)
 
@@ -211,23 +233,20 @@ manage_files_pattern(policykit_grant_t,
 
 manage_files_pattern(policykit_grant_t, policykit_var_lib_t, policykit_var_lib_t)
 
-can_exec(policykit_grant_t, policykit_grant_exec_t)
-
-domtrans_pattern(policykit_grant_t, policykit_auth_exec_t, policykit_auth_t)
-domtrans_pattern(policykit_grant_t, policykit_resolve_exec_t, policykit_resolve_t)
 
 auth_domtrans_chk_passwd(policykit_grant_t)
 auth_use_nsswitch(policykit_grant_t)
 
+logging_send_syslog_msg(policykit_grant_t)
+
 userdom_read_all_users_state(policykit_grant_t)
 
 optional_policy(`
 	cron_manage_system_job_lib_files(policykit_grant_t)
 ')
 
-optional_policy(`
+	optional_policy(`
 	dbus_system_bus_client(policykit_grant_t)
-
 	optional_policy(`
 		consolekit_dbus_chat(policykit_grant_t)
 	')
@@ -235,26 +254,28 @@ optional_policy(`
 
 ########################################
 #
-# Resolve local policy
+# polkit_resolve local policy
 #
 
 allow policykit_resolve_t self:capability { setuid sys_nice };
-allow policykit_resolve_t self:unix_stream_socket { accept listen };
 
-ps_process_pattern(policykit_resolve_t, policykit_domain)
+allow policykit_resolve_t self:unix_dgram_socket create_socket_perms;
+allow policykit_resolve_t self:unix_stream_socket create_stream_socket_perms;
+
+policykit_domtrans_auth(policykit_resolve_t)
 
 read_files_pattern(policykit_resolve_t, policykit_reload_t, policykit_reload_t)
 
 read_files_pattern(policykit_resolve_t, policykit_var_lib_t, policykit_var_lib_t)
 
 can_exec(policykit_resolve_t, policykit_resolve_exec_t)
+corecmd_search_bin(policykit_resolve_t)
 
-domtrans_pattern(policykit_resolve_t, policykit_auth_exec_t, policykit_auth_t)
-
-mcs_ptrace_all(policykit_resolve_t)
 
 auth_use_nsswitch(policykit_resolve_t)
 
+logging_send_syslog_msg(policykit_resolve_t)
+
 userdom_read_all_users_state(policykit_resolve_t)
 
 optional_policy(`
@@ -266,6 +287,6 @@ optional_policy(`
 ')
 
 optional_policy(`
+	kernel_search_proc(policykit_resolve_t)
 	hal_read_state(policykit_resolve_t)
 ')
-
Index: serefpolicy-contrib-20140730/polipo.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/polipo.fc
+++ serefpolicy-contrib-20140730/polipo.fc
@@ -1,15 +1,16 @@
-HOME_DIR/\.forbidden	--	gen_context(system_u:object_r:polipo_config_home_t,s0)
 HOME_DIR/\.polipo	--	gen_context(system_u:object_r:polipo_config_home_t,s0)
 HOME_DIR/\.polipo-cache(/.*)?	gen_context(system_u:object_r:polipo_cache_home_t,s0)
 
-/etc/polipo(/.*)?	gen_context(system_u:object_r:polipo_conf_t,s0)
+/etc/polipo(/.*)?	gen_context(system_u:object_r:polipo_etc_t,s0)
 
 /etc/rc\.d/init\.d/polipo	--	gen_context(system_u:object_r:polipo_initrc_exec_t,s0)
 
+/usr/lib/systemd/system/polipo.*  --              gen_context(system_u:object_r:polipo_unit_file_t,s0)
+
 /usr/bin/polipo	--	gen_context(system_u:object_r:polipo_exec_t,s0)
 
 /var/cache/polipo(/.*)?	gen_context(system_u:object_r:polipo_cache_t,s0)
 
 /var/log/polipo.*	--	gen_context(system_u:object_r:polipo_log_t,s0)
 
-/var/run/polipo(/.*)?	gen_context(system_u:object_r:polipo_var_run_t,s0)
+/var/run/polipo(/.*)?	gen_context(system_u:object_r:polipo_pid_t,s0)
Index: serefpolicy-contrib-20140730/polipo.if
===================================================================
--- serefpolicy-contrib-20140730.orig/polipo.if
+++ serefpolicy-contrib-20140730/polipo.if
@@ -1,8 +1,8 @@
-## <summary>Lightweight forwarding and caching proxy server.</summary>
+## <summary>Caching web proxy.</summary>
 
 ########################################
 ## <summary>
-##	Role access for Polipo session.
+##	Role access for polipo session.
 ## </summary>
 ## <param name="role">
 ##	<summary>
@@ -11,14 +11,13 @@
 ## </param>
 ## <param name="domain">
 ##	<summary>
-##	User domain for the role.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
 template(`polipo_role',`
 	gen_require(`
-		type polipo_session_t, polipo_exec_t, polipo_config_home_t;
-		type polipo_cache_home_t;
+		type polipo_session_t, polipo_exec_t;
 	')
 
 	########################################
@@ -33,15 +32,11 @@ template(`polipo_role',`
 	# Policy
 	#
 
-	allow $2 polipo_cache_home_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 { polipo_cache_home_t polipo_config_home_t }:file { manage_file_perms relabel_file_perms };
-
-	userdom_user_home_dir_filetrans($2, polipo_config_home_t, file, ".forbidden")
-	userdom_user_home_dir_filetrans($2, polipo_config_home_t, file, ".polipo")
-	userdom_user_home_dir_filetrans($2, polipo_cache_home_t, dir, ".polipo-cache")
-
-	allow $2 polipo_session_t:process { ptrace signal_perms };
+	allow $2 polipo_session_t:process signal_perms;
 	ps_process_pattern($2, polipo_session_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $2 polipo_session_t:process ptrace;
+	')
 
 	tunable_policy(`polipo_session_users',`
 		domtrans_pattern($2, polipo_exec_t, polipo_session_t)
@@ -52,57 +47,129 @@ template(`polipo_role',`
 
 ########################################
 ## <summary>
-##	Execute Polipo in the Polipo
-##	system domain.
+##	Create configuration files in user
+##	home directories with a named file
+##	type transition.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`polipo_initrc_domtrans',`
+interface(`polipo_named_filetrans_config_home_files',`
 	gen_require(`
-		type polipo_initrc_exec_t;
+		type polipo_config_home_t;
 	')
 
-	init_labeled_script_domtrans($1, polipo_initrc_exec_t)
+	userdom_user_home_dir_filetrans($1, polipo_config_home_t, file, ".polipo")
+')
+
+########################################
+## <summary>
+##	Create cache directories in user
+##	home directories with a named file
+##	type transition.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`polipo_named_filetrans_cache_home_dirs',`
+	gen_require(`
+		type polipo_cache_home_t;
+	')
+
+	userdom_user_home_dir_filetrans($1, polipo_cache_home_t, dir, ".polipo-cache")
 ')
 
 ########################################
 ## <summary>
-##	Create specified objects in generic
-##	log directories with the polipo
-##	log file type.
+##	Create configuration files in admin
+##	home directories with a named file
+##	type transition.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object_class">
+#
+interface(`polipo_named_filetrans_admin_config_home_files',`
+	gen_require(`
+		type polipo_config_home_t;
+	')
+
+	userdom_admin_home_dir_filetrans($1, polipo_config_home_t, file, ".polipo")
+')
+
+########################################
+## <summary>
+##	Create cache directories in admin
+##	home directories with a named file
+##	type transition.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	Class of the object being created.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="name" optional="true">
+#
+interface(`polipo_named_filetrans_admin_cache_home_dirs',`
+	gen_require(`
+		type polipo_cache_home_t;
+	')
+
+	userdom_admin_home_dir_filetrans($1, polipo_cache_home_t, dir, ".polipo-cache")
+')
+
+########################################
+## <summary>
+##	Create log files with a named file
+##	type transition.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	The name of the object being created.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`polipo_log_filetrans_log',`
+interface(`polipo_named_filetrans_log_files',`
 	gen_require(`
 		type polipo_log_t;
 	')
 
-	logging_log_filetrans($1, polipo_log_t, $2, $3)
+	logging_log_named_filetrans($1, polipo_log_t, file, "polipo")
+')
+
+########################################
+## <summary>
+##	Execute polipo server in the polipo domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`polipo_systemctl',`
+	gen_require(`
+		type polipo_t;
+		type polipo_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+	allow $1 polipo_unit_file_t:file read_file_perms;
+	allow $1 polipo_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, polipo_t)
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an polipo environment.
+##	Administrate an polipo environment.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -118,27 +185,35 @@ interface(`polipo_log_filetrans_log',`
 #
 interface(`polipo_admin',`
 	gen_require(`
-		type polipo_system_t, polipo_initrc_exec_t, polipo_cache_t;
-		type polipo_conf_t, polipo_log_t, polipo_var_run_t;
+		type polipo_t, polipo_pid_t, polipo_cache_t;
+		type polipo_etc_t, polipo_log_t, polipo_initrc_exec_t;
+		type polipo_unit_file_t;
 	')
 
-	allow $1 polipo_system_t:process { ptrace signal_perms };
-	ps_process_pattern($1, polipo_system_t)
+	allow $1 polipo_t:process signal_perms;
+	ps_process_pattern($1, polipo_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 polipo_t:process ptrace;
+	')
 
-	polipo_initrc_domtrans($1)
+	init_labeled_script_domtrans($1, polipo_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 polipo_initrc_exec_t system_r;
 	allow $2 system_r;
 
-	files_search_var($1)
-	admin_pattern($1, polipo_cache_t)
-
-	files_search_etc($1)
-	admin_pattern($1, polipo_conf_t)
+	files_list_etc($1)
+	admin_pattern($1, polipo_etc_t)
 
-	logging_search_logs($1)
+	logging_list_logs($1)
 	admin_pattern($1, polipo_log_t)
 
-	files_search_pids($1)
-	admin_pattern($1, polipo_var_run_t)
+	files_list_var($1)
+	admin_pattern($1, polipo_cache_t)
+
+	files_list_pids($1)
+	admin_pattern($1, polipo_pid_t)
+
+	polipo_systemctl($1)
+	admin_pattern($1, polipo_unit_file_t)
+	allow $1 polipo_unit_file_t:service all_service_perms;
 ')
